# ENDER

**Ender is a full featured package manager for your browser**

It allows you to search, install, manage, and compile front-end JavaScript packages and their dependencies for the web. We like to think of it as [NPM](https://github.com/isaacs/npm)'s little sister.

**Ender is not a JavaScript library**

It's not a jQuery replacement. It's not even a static asset. It's a tool for making the consumption of front-end JavaScript packages dead simple and incredibly powerful.

![Ender](http://f.cl.ly/items/1W0P3I3D3m3U0e1j2h1c/Screen%20shot%202011-05-09%20at%2011.31.42%20AM.png)

## WHY?

In the browser - **small, loosely coupled modules are the future and large, tightly-bound monolithic libraries are the past!**

Ender capitalizes on this by offering a unique way to bring together the exciting work happening in JavaScript packages and allows you to mix, match, and customize your own build, suited to your individual needs, without all the extra cruft that comes with larger libraries.

With Ender, if one library goes bad or unmaintained, it can be replaced with another. Need a specific package version? No problem! Does your package have dependencies? Let us handle that for you too!

## MORE INFO

For more information checkout [http://ender.jit.su](http://ender.jit.su)

## BUILD STATUS

**Ender** [![Build Status](https://secure.travis-ci.org/ender-js/Ender.png)](http://travis-ci.org/ender-js/Ender)

[Ender Args Parser](https://github.com/ender-js/ender-args-parser) [![Build Status](https://secure.travis-ci.org/ender-js/ender-args-parser.png)](http://travis-ci.org/ender-js/ender-args-parser)

[Ender Builder](https://github.com/ender-js/ender-builder) [![Build Status](https://secure.travis-ci.org/ender-js/ender-builder.png)](http://travis-ci.org/ender-js/ender-builder)

[Ender Dependency Graph](https://github.com/ender-js/ender-dependency-graph) [![Build Status](https://secure.travis-ci.org/ender-js/ender-dependency-graph.png)](http://travis-ci.org/ender-js/ender-dependency-graph)

[Ender Installer](https://github.com/ender-js/ender-installer) [![Build Status](https://secure.travis-ci.org/ender-js/ender-installer.png)](http://travis-ci.org/ender-js/ender-installer)

[Ender Minify](https://github.com/ender-js/ender-minify) [![Build Status](https://secure.travis-ci.org/ender-js/ender-minify.png)](http://travis-ci.org/ender-js/ender-minify)

[Ender Package Util](https://github.com/ender-js/ender-package-util) [![Build Status](https://secure.travis-ci.org/ender-js/ender-package-util.png)](http://travis-ci.org/ender-js/ender-package-util)

[Ender Repository](https://github.com/ender-js/ender-repository) [![Build Status](https://secure.travis-ci.org/ender-js/ender-repository.png)](http://travis-ci.org/ender-js/ender-repository)

## Licence

Ender is Copyright (c) 2012-2013 Dustin Diaz [@ded](https://twitter.com/ded), Jacob Thornton [@fat](https://twitter.com/fat) and Rod Vagg [@rvagg](https://twitter.com/rvagg) and licensed under the MIT license. All rights not explicitly granted in the MIT license are reserved. See the included LICENSE file for more details.